<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
    <div v-if="selectedMethod === 'bulk'" class="method-bulk">
        <div class="step-spacer">
            <div class="field field-modal-big-label">
                <label for="" class="label">File name</label>
                <input type="text" name="name" required v-model="bulkFileName" data-error-message="Fill in this field." />
                <span class="max-characters">
                    <span class="text">Max. 30 characters</span><span
                        class="separator"></span>
                    <button> <i class="icon-delete"></i></button>
                </span>
            </div>
        </div>
        <div class="step-spacer">
            <div class="boxs-wrapper">
                <!-- <div class="modal-input col">
                    <label for="file_name">File Name</label>
                    <input type="text" name="file_name" id="file_name" minlength="3"
                        required />
                </div> -->
                <CustomSelect class="col" :options="fileType" defaultTitle="File type"
                    name="file_type" @selected="file_type_value" />
            </div>
            <div class="boxs-wrapper">
                <div class="modal-input col">
                    <label for="field-delimiter">Field Delimiter</label>
                    <input type="text" name="field_delimiter" id="field_delimiter"
                        v-model="fieldDelimiter">
                </div>
                <div class="modal-input col">
                    <label for="decimal_delimiter">Decimal Delimiter</label>
                    <input type="text" name="decimal_delimiter" id="decimal_delimiter"
                        v-model="decimalDelimiter">
                </div>
            </div>
        </div>
        <div class="step-spacer">
            <div>
                <label for="" class="label">Import the file</label>
                <div class="field field-modal-big-label">
                    <div class="boxs-wrapper">
                        <div class="box-buttons upload-file">
                            <input type="file" id="bulk-file" :accept="allowedFileTypes" @change="upload($event)">
                            <label class="box" for="bulk-file">
                                <span class="text">
                                    <i class="icon-upload"></i>
                                    <span v-if="bulkUploadFileName">{{ bulkUploadFileName
                                        }}</span>
                                    <span v-else>Import new file</span>
                                </span>
                            </label>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <ClientOnly>
        <Teleport to="#modals-container">
            <ModalsModalFeedback v-if="showFeedback" :feedback="feedbackMessage" @toggle="close"/>
        </Teleport>
    </ClientOnly>
</template>

<script setup lang="ts">

import { ref } from 'vue';
import type { Domain } from '~/interfaces/types';

// Define the component's props
// - selectedMethod: A string indicating the selected method (e.g., bulk, streaming, database)
// - createdDatasetId: ID of the created dataset used for associating uploaded files
// - gotoStep: Function that allows transitioning between different steps of the process
// - domains: Array that contains information about different domains (platforms, data types, etc.)
const props = defineProps({
    selectedMethod: String,
    createdDatasetId: String,
    gotoStep: {
      type: Function,
      required: true,
    },
    domains: {
        type: Array as PropType<Domain[]>,
        required: true,
    }
});

console.log('Bulk component loaded', props.createdDatasetId);

// Define various reactive variables
const bulkFileName = ref<string>(''); // Holds the name of the bulk file to be uploaded
const file_type = ref(''); // Holds the selected file type (csv, json, etc.)
const fieldDelimiter = ref<string>(','); // Field delimiter, default is comma for CSV
const decimalDelimiter = ref<string>('.'); // Decimal delimiter, default is period
const feedbackMessage = ref({ type: '', message: '' });
const showFeedback = ref(false);

const close = () => {
    showFeedback.value = false;
};

// Available file types that the user can choose from
const fileType = [
    { id: 1, name: 'csv' },
    { id: 2, name: 'json' },
    { id: 3, name: 'xml' },
    { id: 4, name: 'jsonl' },
];

/**
 * Sets the value of the file_type reactive variable to the given event value
 * @param {any} event - The event containing the selected file type
 */
const file_type_value = (event: any) => {
    file_type.value = event;
}

const allowedFileTypes = computed(() => {
    switch (file_type.value) {
        case 'csv':
            return '.csv';
        case 'json':
            return '.json';
        case 'xml':
            return '.xml';
        case 'jsonl':
            return '.jsonl';
        default:
            return ''; // Allow all if no type is selected
    }
});

// Reactive variable to hold the name of the uploaded file
const bulkUploadFileName = ref<string>('');

/**
 * Handles file upload by the user. If the user has selected a file, updates the
 * bulkUploadFileName reactive variable with the name of the uploaded file.
 * @param {any} event - The event containing information about the uploaded file
 */

const upload = (event: any) => {
    bulkUploadFileName.value = '';
    if (event.target.files.length === 0) return;

    const file = event.target.files[0];

    bulkUploadFileName.value = file.name;
}

/**
 * Handles the submission of a bulk file by the user. The function checks if a file
 * has been selected and if the file name is not empty. If these conditions are met,
 * it creates a new artifact and then uses the artifact ID to request a signed URL
 * for MinIO. The file is then uploaded with the signed URL and the bulk info is
 * registered for the pipeline.
 * @returns {Promise<void>}
 */
const handleSubmitBulk = async () => {
    let outputColor = "color:green; font-size:20px;"

    // check if file to uploadis selected
    var fileToUpload = (document.getElementById("bulk-file") as HTMLInputElement)?.files;
    if (!fileToUpload || fileToUpload?.length == 0) {
        alert('Please select a file to upload');
        return;
    }
    var singleFile = fileToUpload[0];

    // Check if a file name has been entered
    if (bulkFileName.value === '') {
        alert('Please enter a file name');
        return;
    }

    console.log('%c bulk submit init. gonna save on datasetid: ' + props.createdDatasetId, outputColor);

    // Step 1: Create artifact data to be uploaded
    const data = {
        name: bulkFileName.value,
        description: bulkFileName.value + " description",
        summary: bulkFileName.value + " summary",
        distributions: [
            {
                accessUrl: "test1",
                title: bulkFileName.value,
                description: "test2",
                fieldDelimiter: ",",
                decimalDelimiter: "."
            }
        ],
        metadata: {
            identifier: "asd1",
            title: "asd2",
            description: "asd3"
        },
        catalogId: props.createdDatasetId
    }

    let createdArtifactId: string | null = null; // Initialize the artifact ID as null

    // Start loading indicator
    updateLoadingUI(true);

    try {
        // Step 2: Create an artifact by sending a POST request
        const artifactResponse: any = await useFetchAuth('/structuredFiles', {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json'
            },
            body: data
        }, useRuntimeConfig().public.API_DATAMITE_URL);

        console.log('%c artifact id: ' + artifactResponse.id, outputColor);
        createdArtifactId = artifactResponse.id;

        // Step 3: Get the signed URL from MinIO for file upload
        updateLoadingUI(true);
        let fileName = singleFile.name; // Get the file name from the uploaded file
        console.log(fileName);
        const uploadLocation: any = await useFetchAuth('/storage/artifacts/' + createdArtifactId + '/files/' + fileName + '/upload-location', {
        }, useRuntimeConfig().public.API_DATAMITE_DATA_STORAGE);
        updateLoadingUI(false);

        // response example
        // "url": "http://91.235.109.231:9000/default/29c53e97-52b2-436b-a819-b740bcc64a96/asd?X-Amz-Algorithm=AWS4-HMAC-SHA256&X-Amz-Date=20240917T185649Z&X-Amz-SignedHeaders=host&X-Amz-Credential=minioadmin%2F20240917%2Fus-east-1%2Fs3%2Faws4_request&X-Amz-Expires=600&X-Amz-Signature=22132620c9be00cc392e705de16a428e64bf14fb988a1db8dc77d158cab943e7"

        // Step 4: Use the signed URL to upload the file to MinIO
        console.log('%c upload location: ' + uploadLocation.url, outputColor);

        updateLoadingUI(true);
        fetch(uploadLocation.url, {
            method: 'PUT',
            body: singleFile
        }).then((a) => {
            console.log('%c upload done!', outputColor);

            // Step 5: Register bulk information for the pipeline
            const streamingPipelineData: any = {
                name: fileName,
                file_type: file_type.value,
                consolidation_type: "SIZE",
                consolidation_value: 1,
                resource_name: fileName,
                description: "string",
                dataset_id: props.createdDatasetId,
                field_delimiter: fieldDelimiter.value,
                decimal_delimiter: decimalDelimiter.value,
                source_data: {
                    source_type: "bulk",
                    artifact_id: createdArtifactId,
                    encoding: "utf_8",
                    quality_dataset: "string"
                }
            }

            // Send the request to register the streaming pipeline
            updateLoadingUI(true);
            useFetchAuth('/streamings/', {
                method: 'POST',
                body: JSON.stringify(streamingPipelineData)
            }, useRuntimeConfig().public.API_DATAMITE_STREAMING_SERVICE).then((response: any) => {

                if (!response.id) {
                    updateLoadingUI(false);
                    showFeedback.value = true;
                    feedbackMessage.value = {
                        type: 'error',
                        message: 'Error creating streaming pipeline:' + response,
                    };
                }

                console.log('%c streamingPipeline done', outputColor);

                // Step 6: Start the streaming pipeline
                useFetchAuth('/streamings/' + response.id + '/start', {
                    method: 'PUT'
                }, useRuntimeConfig().public.API_DATAMITE_STREAMING_SERVICE).then((response: any) => {
                    showFeedback.value = true;
                    feedbackMessage.value = {
                        type: 'success',
                        message: 'Dataset created successfully!',
                    };
                    setTimeout(() => {
                        feedbackMessage.value = { type: '', message: '' };
                        showFeedback.value = false;
                        props.gotoStep(3);
                        updateLoadingUI(false); // Stop the loading indicator
                    }, 3000);
                });

            });

        }).catch((e) => {
            updateLoadingUI(false);
            console.error(e);
            const errorData = e.response._data.message || e;
            showFeedback.value = true;
            feedbackMessage.value = {
                type: 'error',
                message: 'An error occurred:' + errorData,
            };
        });

    } catch (error: any) {
        updateLoadingUI(false);

        if (error.response) {
            // Handle response errors
            showFeedback.value = true;
            feedbackMessage.value = {
                type: 'error',
                message: 'Error submitting data:' + error.message
            };
            console.error('Error submitting data:', error.response.status, error.response._data || error.message);
        } else {
            // Handle other errors
            showFeedback.value = true;
            feedbackMessage.value = {
                type: 'error',
                message: 'Error submitting data:' + error
            };
            console.error('Error during fetch:', error.message || error);
        }

    }

}

// Expose the handleSubmitBulk method to the parent component
defineExpose({
    handleSubmitBulk
});
</script>